/*
 * generated by Xtext 2.29.0
 */
package org.eclipse.papyrus.robotics.xtext.datatypes.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.papyrus.robotics.xtext.datatypes.dTML.DTMLPackage;
import org.eclipse.papyrus.robotics.xtext.datatypes.dTML.Property;
import org.eclipse.papyrus.robotics.xtext.datatypes.dTML.Value;
import org.eclipse.papyrus.robotics.xtext.datatypes.dTML.XAssignment;
import org.eclipse.papyrus.robotics.xtext.datatypes.dTML.XDataType;
import org.eclipse.papyrus.robotics.xtext.datatypes.dTML.XEnumLiteral;
import org.eclipse.papyrus.robotics.xtext.datatypes.dTML.XEnumeration;
import org.eclipse.papyrus.robotics.xtext.datatypes.services.DTMLGrammarAccess;
import org.eclipse.papyrus.uml.textedit.common.xtext.serializer.UmlCommonSemanticSequencer;
import org.eclipse.papyrus.uml.textedit.common.xtext.umlCommon.BoundSpecification;
import org.eclipse.papyrus.uml.textedit.common.xtext.umlCommon.MultiplicityRule;
import org.eclipse.papyrus.uml.textedit.common.xtext.umlCommon.QualifiedName;
import org.eclipse.papyrus.uml.textedit.common.xtext.umlCommon.TypeRule;
import org.eclipse.papyrus.uml.textedit.common.xtext.umlCommon.UmlCommonPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;

@SuppressWarnings("all")
public class DTMLSemanticSequencer extends UmlCommonSemanticSequencer {

	@Inject
	private DTMLGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == DTMLPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case DTMLPackage.PROPERTY:
				sequence_Property(context, (Property) semanticObject); 
				return; 
			case DTMLPackage.VALUE:
				sequence_Value(context, (Value) semanticObject); 
				return; 
			case DTMLPackage.XASSIGNMENT:
				sequence_XAssignment(context, (XAssignment) semanticObject); 
				return; 
			case DTMLPackage.XDATA_TYPE:
				sequence_XDataType(context, (XDataType) semanticObject); 
				return; 
			case DTMLPackage.XENUM_LITERAL:
				sequence_XEnumLiteral(context, (XEnumLiteral) semanticObject); 
				return; 
			case DTMLPackage.XENUMERATION:
				sequence_XEnumeration(context, (XEnumeration) semanticObject); 
				return; 
			}
		else if (epackage == UmlCommonPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case UmlCommonPackage.BOUND_SPECIFICATION:
				sequence_BoundSpecification(context, (BoundSpecification) semanticObject); 
				return; 
			case UmlCommonPackage.MULTIPLICITY_RULE:
				sequence_MultiplicityRule(context, (MultiplicityRule) semanticObject); 
				return; 
			case UmlCommonPackage.QUALIFIED_NAME:
				sequence_QualifiedName(context, (QualifiedName) semanticObject); 
				return; 
			case UmlCommonPackage.TYPE_RULE:
				sequence_TypeRule(context, (TypeRule) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * <pre>
	 * Contexts:
	 *     Property returns Property
	 *
	 * Constraint:
	 *     (name=ID (type=TypeRule | typeUndefined?='&lt;Undefined&gt;')? multiplicity=MultiplicityRule? value=Value? comment=VSL_COMMENT?)
	 * </pre>
	 */
	protected void sequence_Property(ISerializationContext context, Property semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Value returns Value
	 *
	 * Constraint:
	 *     (str=STRING | ival=INT | dval=DOUBLE)
	 * </pre>
	 */
	protected void sequence_Value(ISerializationContext context, Value semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Model returns XAssignment
	 *     XAssignment returns XAssignment
	 *
	 * Constraint:
	 *     (name=ID expression=ExpressionString)
	 * </pre>
	 */
	protected void sequence_XAssignment(ISerializationContext context, XAssignment semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, DTMLPackage.Literals.MODEL__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DTMLPackage.Literals.MODEL__NAME));
			if (transientValues.isValueTransient(semanticObject, DTMLPackage.Literals.XASSIGNMENT__EXPRESSION) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DTMLPackage.Literals.XASSIGNMENT__EXPRESSION));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getXAssignmentAccess().getNameIDTerminalRuleCall_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getXAssignmentAccess().getExpressionExpressionStringParserRuleCall_2_0(), semanticObject.getExpression());
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Model returns XDataType
	 *     XDataType returns XDataType
	 *
	 * Constraint:
	 *     (name=ID attributes+=Property*)
	 * </pre>
	 */
	protected void sequence_XDataType(ISerializationContext context, XDataType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     XEnumLiteral returns XEnumLiteral
	 *
	 * Constraint:
	 *     (name=ID value=Value? comment=VSL_COMMENT?)
	 * </pre>
	 */
	protected void sequence_XEnumLiteral(ISerializationContext context, XEnumLiteral semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Model returns XEnumeration
	 *     XEnumeration returns XEnumeration
	 *
	 * Constraint:
	 *     (name=ID literals+=XEnumLiteral*)
	 * </pre>
	 */
	protected void sequence_XEnumeration(ISerializationContext context, XEnumeration semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
